c predgrid.f (Aug 12, 1995)
c ----------------------------------------------------------------------
      PROGRAM predgrid
c ######################################################################
c A program to evaluate the estimated function on sphere by HAS
c     on a regular grid (NGLAT x NGLONG).
c The output from has_sphere.f, out.isb and out.coef,  will be used.
c ######################################################################
      INTEGER NOBS,NNULL,NPAR,MAXBAS,
     & NGLAT,NGLONG, LLAT,ULAT,LLONG,ULONG
      PARAMETER(NOBS=725,NNULL=1,NPAR=446,MAXBAS=500,
     & NGLAT=100,NGLONG=100, LLAT=35,ULAT=70,LLONG=-30,ULONG=10)

      INTEGER ISB(MAXBAS)
      DOUBLE PRECISION X(NOBS,2),DUM,COEF(MAXBAS), GLAT,GLONG,PY

      DOUBLE PRECISION  PREDSP

      OPEN(UNIT=4,FILE="samplesp.data",STATUS="OLD")
      DO 10 I=1,NOBS
         READ(4,*) X(I,1),X(I,2),DUM
 10   CONTINUE
      CLOSE(UNIT=4)

      OPEN(UNIT=6, FILE="out.isb",STATUS="OLD")
      READ(6,*) (ISB(I),I=1,MAXBAS)
      CLOSE(UNIT=6)

      OPEN(UNIT=8,FILE="out.coef",STATUS="OLD")
      READ(8,*)  (COEF(I),I=1,NPAR)
      CLOSE(8)

      OPEN(UNIT=10,FILE="out.hasfit.grid",STATUS="UNKNOWN")
      DO 81 I = 1,NGLAT
         GLAT = DBLE(LLAT) + (DBLE(I)-.5D0)/DBLE(NGLAT) * 
     &        DBLE(ULAT-LLAT)
         DO 82 J = 1,NGLONG
            GLONG = DBLE(LLONG)+(DBLE(J)-.5D0)/DBLE(NGLONG) * 
     &           DBLE(ULONG-LLONG)
            PY = PREDSP(GLAT,GLONG,NOBS,NNULL,NPAR,X,ISB,COEF)
            WRITE(10,*) SNGL(PY)
 82      CONTINUE
 81   CONTINUE
      CLOSE(UNIT=50)


      STOP
      END

