c nbgcv.f, (Aug 12 1995, 17:25)
c ----------------------------------------------------------------------
      SUBROUTINE NBGCV (NOBS,NNULL,RSS,MAXBAS,IDF,NB,GCV)
c########################################################################c
c Use GCV(modified) to decide how many basis to be used.
c 
c Input:
c     NOBS,NNULL,MAXBAS,IDF: same as in has_cubic.f
c     RSS(MAXBAS): output from presele.
c Output:
c     NB: the number of basis functions chosen by modified GCV criterion
c     GCV(MAXBAS): GCV scores correponding to RSS
c Functions used: idamin
c########################################################################c
      INTEGER NOBS,NNULL,MAXBAS,NB,MBAS
      DOUBLE PRECISION RSS(*),GCV(*),IDF
      INTEGER IDAMIN
      MBAS = MIN(MAXBAS, INT(DBLE(NOBS-NNULL)/IDF)+NNULL)
      DO 10 I=NNULL,MBAS
         GCV(I) = (RSS(I)/DBLE(NOBS))/(1.D0-(IDF*DBLE(I-NNULL)+
     &        DBLE(NNULL))/DBLE(NOBS))**2
 10   CONTINUE
      NB = IDAMIN(MBAS-(NNULL-1),GCV(NNULL),1)+(NNULL-1)
      RETURN
      END

      
