c predcu.f, (Aug 12 1995)
c ----------------------------------------------------------------------
      DOUBLE PRECISION FUNCTION PREDCU (T,NNULL,NPAR,X,ISB,COEF)
c########################################################################c
c A function to evaluate the estimated function on [0,1].
c
c Input:
c     T:      a point in [0,1] at which the function
c             to be evaluated
c     NNULL, NPAR, X(NOBS), ISB(MAXBAS), COEF(MAXBAS): 
c             same as in has.f, 
c             ISB and COEF are the results from HAS fit.
c Functions used: FNULL, RK (in basiscu.f)
c########################################################################c
      INTEGER NNULL,NPAR,ISB(*)
      DOUBLE PRECISION T,X(*),COEF(*)
      DOUBLE PRECISION FNULL,RK
      PREDCU = 0.D0
      DO 10 M = 1,NNULL
         PREDCU = PREDCU + COEF(M) * FNULL(M,T)
 10   CONTINUE
      DO 20 I = NNULL+1,NPAR
         PREDCU = PREDCU + COEF(I) * RK(T,X(ISB(I)-NNULL))
 20   CONTINUE
      RETURN 
      END
